/* VGA Registers And Bits */
#define MY_MEMSIZE 0x200000 /* 2MB - should come from VideoRAM in Xconfig */
#define MY_MEMCONFIG 2
    /*MEMCONFIG = 2 for single Buf, 2 MB pg 20 and in viper.ini ,
      resolution independent*/
#define MY_SRTCTL 0x000001E5 /* "srtctc" value from from viper.ini ,res-independent*/
#define MY_BYTES_PER_PIXEL 1 /* only 8-bit color so far - should be variable */
#define NEGATIVE 0  /* for negative sync polarity */
#define POSITIVE 1  /* for positive sync polarity */
#define MY_VP POSITIVE  /* from viper.ini as reported by ini2xconfig -
                               could be monitor/res dependent */
#define MY_HP POSITIVE  /* from viper.ini as reported by ini2xconfig -
                               could be monitor/res dependent */
#define MY_CLK2X 0    /* from viper.ini as reported by ini2xconfig -
                                - probably only used for 1600x1200 ?? */
#define MY_MEMSPEED 55190075  /* freq in hz derived from viper.ini :

memspeed clock  "control word" = 0x679C35
  which breaks down like this:
	register select=3
	Index Field       =3=0x3
	Feedback_Divider_P=106=0x6A
	Post_VCO_Divider_M=0
	Q_Divider=55=0x37
	VCOFreq=55190075 Hz, FinalFreq=55190075 Hz */

#define MY_PHYSADDR 0x80000000 /* reported from viper.ini by ini2xconfig
                                  as "viper base address" */
/***********from common/x386.h******************/
typedef struct {
  unsigned char red, green, blue;
} RgbRec, *RgbPtr;

/*
 * structure common for all modes
 */
typedef struct _DispM {
  struct _DispM	*prev,*next;
  char		*name ; /* identifier of this mode */
  int		Clock ;              /* doclock */
  int           HDisplay ;           /* horizontal timing */
  int           HSyncStart ;
  int           HSyncEnd;
  int           HTotal;
  int           VDisplay;           /* vertical timing */
  int           VSyncStart;
  int           VSyncEnd;
  int           VTotal;
  int           Flags;
 } DisplayModeRec, *DisplayModePtr ;

typedef struct
 {
  unsigned char red ;
  unsigned char green ;
  unsigned char blue ;
 } PALETTE ;

extern void makepalette ( RgbPtr Palette ) ;
/* P9000 Regester Address And Value Defines */
/*  video control registers */
#define SRTCTL ( 0x00138 / 4 ) /* P9000 Reg Offset For En/Dis/Abling Video */
int Init ( int bytesperpixel , DisplayModePtr currentmode ,
         volatile int * controlregbase ) ;
